<script setup lang="ts">
import { ref, onMounted, watch } from "vue";
import { useCounterMixin } from "@/stores/mixin";
import http from "@/plugins/http";
import config from "@/app.config";
import { useResultDataStore } from "@/modules/07_insignia/storeResult";

import DialogForm from "@/modules/07_insignia/components/3_result/DialogForm.vue";
import fileUploadview from "../components/3_result/fileUpload.vue";

import type { OptionData } from "@/modules/07_insignia/interface/index/Main";
import type { QTableProps, QInput } from "quasar";
import { useQuasar } from "quasar";

const DataStore = useResultDataStore();
const mixin = useCounterMixin();
const {
  date2Thai,
  dialogConfirm,
  showLoader,
  hideLoader,
  messageError,
  success,
} = mixin;
const $q = useQuasar();
const tab = ref<string>("");

const selectRound = ref<string>();
const selectRoundOption = ref<OptionData[]>([]);
const modal = ref<boolean>(false);
const action = ref<string>("");
const personId = ref<string>();
const profileType = ref<string>("");
const fileResult = ref<any>(null);
const fileinvoice = ref<any>(null);
const loadView = ref<boolean>(false);
onMounted(async () => {
  await fecthRound();
  // await fecthInsignia();
  // await fecthInsigniaType();
});
const fecthRound = async () => {
  showLoader();
  await http
    .get(config.API.noteround())
    .then(async (res) => {
      let data = res.data.result;
      if (data.length !== 0) {
        selectRoundOption.value = data.map((e: any) => ({
          name: "รอบการเสนอขอพระราชทานเครื่องราชปี" + "  " + (e.year + 543),
          id: e.id,
        }));
        selectRound.value = data[0].id;
        await fecthInsignia();
        await fecthInsigniaType();
      }
    })
    .catch((err) => {
      console.log(err);
    })
    .finally(() => {
      hideLoader();
    });
};
const fecthInsignia = async () => {
  await http
    .get(config.API.insignia)
    .then((res) => {
      let data = res.data.result;
      DataStore.fetchDatainsignia(data);
    })
    .catch((err) => {
      messageError($q, err);
      console.log("fecthInsignia");
    });
};
const fecthInsigniaType = async () => {
  await http(config.API.insigniaType)
    .then((res) => {
      let data = res.data.result;
      DataStore.fetchDatainsigniaType(data);
      tab.value = DataStore.insigniaType[0].name;
      loadView.value = true;
    })
    .catch((err) => {
      messageError($q, err);
      console.log("fecthInsigniaType");
    });
};
const visibleColumns = ref<String[]>([
  "no",
  "status",
  "citizenId",
  "name",
  "type",
  "dateReceive",
  "date",
  "employeeType",
  "volumeNo",
  "section",
  "page",
  "number",
  "vatnumber",
  "datepay",
  "typepay",
  "address",
  "action",
]);
const columns = ref<QTableProps["columns"]>([
  {
    name: "no",
    align: "left",
    label: "ลำดับ",
    field: "no",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "status",
    align: "left",
    label: "สถานะ",
    field: "status",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "citizenId",
    align: "left",
    label: "เลขประจำตัวประชาชน",
    field: "citizenId",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "name",
    align: "left",
    label: "ชื่อ - สกุล",
    field: "name",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "employeeType",
    align: "left",
    label: "สถานภาพ",
    field: "employeeType",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "type",
    align: "left",
    label: "เครื่องราชฯ",
    field: "type",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "dateReceive",
    align: "left",
    label: "วันที่ได้รับพระราชทาน",
    field: "dateReceive",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "date",
    align: "left",
    label: "วันที่ในราชกิจนุเบกษา",
    field: "date",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "volumeNo",
    align: "left",
    label: "เล่มที่ในราชกิจนุเบกษา",
    field: "volumeNo",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "section",
    align: "left",
    label: "ตอนที่ในราชกิจนุเบกษา",
    field: "section",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },

  {
    name: "page",
    align: "left",
    label: "หน้าที่ในราชกิจนุเบกษา",
    field: "page",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "number",
    align: "left",
    label: "ลำดับที่ในราชกิจจานุเบกษา",
    field: "number",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "vatnumber",
    align: "left",
    label: "หมายเลขใบกำกับ",
    field: "vatnumber",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "datepay",
    align: "left",
    label: "วันที่จ่ายใบกำกับฯ",
    field: "datepay",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "typepay",
    align: "left",
    label: "รูปแบบการจ่าย",
    field: "typepay",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "address",
    align: "left",
    label: "ที่อยู่ที่จ่าย",
    field: "address",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "action",
    align: "left",
    label: "",
    field: "",
  },
]);
watch(tab, () => {
  if (tab.value !== "doc") {
    fecthlistInsignia();
  }
});
watch(modal, () => {
  if (modal.value == false) {
    fecthlistInsignia();
  }
});
const selectorInsignia = () => {
  fecthlistInsignia();
};
const selectorRound = (round: string) => {
  selectRound.value = round;
};
const fecthlistInsignia = async () => {
  showLoader();
  let data = {
    insigniaTypeId: tab.value,
    insigniaNoteId: selectRound.value,
    insigniaId: DataStore.insignia,
  };
  await http
    .post(config.API.noteSearch(), data)
    .then((res) => {
      let data = res.data.result;
      console.log(data);
      DataStore.fetchlistinsignia(data);
    })
    .catch((err) => {
      console.log(err);
      messageError($q, err);
    })
    .finally(() => {
      hideLoader();
    });
};
const uploadFile = async (event: any, action: string) => {
  if (selectRound.value !== undefined) {
    let id = selectRound.value;
    dialogConfirm($q, async () => {
      const formdata = new FormData();
      formdata.append("file", event);
      await http
        .put(config.API.uploadfileInsignia(action, id), formdata)
        .then(() => {
          success($q, "อัพโหลดไฟล์สำเร็จ");
        })
        .catch((err) => {
          messageError($q, err);
        })
        .finally(async () => {
          await fecthlistInsignia();
          if (action === "receice") {
            fileResult.value = null;
          } else if (action === "invoice") {
            fileinvoice.value = null;
          }

          modelPerview.value = false;
        });
    }),
      "ยืนยันการบันทึกรายการข้อมูล",
      "ต้องการยืนยันรายการข้อมูลนี้หรื้อไม่ ?";
  }
};

const filterRef = ref<QInput>();
const filter = ref<string>("");

const close = () => {
  modal.value = false;
};

const addData = () => {
  modal.value = true;
  action.value = "addData";
};

const editData = (data: any) => {
  personId.value = data.id;
  profileType.value = data.profileType;
  action.value = "editData";
  modal.value = true;
};

const save = () => {
  console.log("save function");
};
const modelPerview = ref<boolean>(false);
const rowspreview = ref<any>([]);
const typepreview = ref<string>("");
const fileInsignia = ref<any>(null);
const perviewfile = async (event: any, actionType: string) => {
  showLoader();
  typepreview.value = actionType;
  fileInsignia.value = event;
  if (selectRound.value !== undefined) {
    let id = selectRound.value.toString();
    const formdata = new FormData();
    formdata.append("file", event);
    await http
      .put(config.API.previewfileInsignia(actionType, id), formdata)
      .then((res) => {
        console.log(res);
        let data = res.data.result;
        rowspreview.value = data.map((e: any) => ({
          id: e.id,
          citizenId: e.citizenId,
          prefix: e.prefix,
          position: e.position,
          status: DataStore.status(e.status),
          dateReceive: date2Thai(e.dateReceive),
          name: e.fullName,
          type: e.requestInsignia,
          employeeType: DataStore.profileType(e.profileType),
          profileType: e.profileType,
          page: e.page,
          number: e.no,
          vatnumber: e.number,
          datepay: date2Thai(e.datePayment),
          typepay: e.typePayment,
          address: e.address,
        }));
      })
      .catch((err) => {
        console.log(err);
      })
      .finally(() => {
        modelPerview.value = true;
        hideLoader();
      });
  }
};

const resetFilter = () => {
  // reset ค่าที่ค้นหาเมื่อกดปุ่ม X ในกล่องค้นหา
  filter.value = "";
  filterRef.value!.focus();
};
const pagination = ref({
  sortBy: "name",
  descending: false,
  page: 1,
  rowsPerPage: 10,
});
const paging = ref<boolean>(true);
const paginationLabel = (start: number, end: number, total: number) => {
  if (paging.value == true) return " " + start + "-" + end + " ใน " + total;
  else return start + "-" + end + " ใน " + total;
};
</script>

<template>
  <div class="toptitle text-dark col-12 row items-center">
    บันทึกผลการได้รับพระราชทานเครื่องราชอิสริยาภรณ์/การจ่ายใบกำกับ
  </div>
  <q-card
    flat
    bordered
    class="col-12 q-my-md q-mt-sm rounded-borders"
    v-if="loadView == true"
  >
    <div class="bg-grey-1 col-12 row items-center">
      <div class="q-pl-md q-pr-sm text-weight-medium text-grey-7">รอบ</div>
      <div>
        <selector
          hide-bottom-space
          borderless
          dense
          lazy-rules
          emit-value
          map-options
          options-dense
          option-label="name"
          option-value="id"
          v-model="selectRound"
          :options="selectRoundOption"
          use-input
          input-debounce="0"
          input-class="text-bold text-grey"
          @update:emit-value="selectorRound"
        >
        </selector>
      </div>
    </div>
    <q-separator />
    <q-tabs
      dense
      v-model="tab"
      align="left"
      class="bg-white text-grey"
      active-color="primary"
      indicator-color="primary"
    >
      <div v-for="item in DataStore.insigniaType">
        <q-tab :name="item.name" :label="item.label" />
      </div>

      <q-tab name="doc" label="เอกสารอ้างอิง" />
    </q-tabs>
    <q-separator />
    <q-tab-panels v-model="tab" animated>
      <q-tab-panel
        v-for="item in DataStore.insigniaType"
        :key="item.name"
        :name="item.name"
        class="q-pa-none"
      >
        <div class="q-pa-md">
          <div class="row col-12 q-pb-sm q-col-gutter-x-xs">
            <div>
              <q-file
                dense
                clearable
                outlined
                v-model="fileResult"
                label="บันทึกผลการได้รับพระราชทานเครื่องราชอิสริยาภรณ์"
                style="min-width: 300px"
                accept=".xlsx"
              >
                <template v-slot:prepend>
                  <q-icon name="attach_file" />
                </template>
                <q-tooltip
                  >อัพโหลดไฟล์บันทึกผลการได้รับพระราชทานเครื่องราชอิสริยาภรณ์</q-tooltip
                >
              </q-file>
            </div>
            <div v-if="fileResult !== null">
              <q-btn
                size="12px"
                flat
                round
                color="add"
                icon="mdi-upload"
                @click="perviewfile(fileResult, 'receice')"
              >
                <q-tooltip
                  >อัพโหลดไฟล์บันทึกผลการได้รับพระราชทานเครื่องราชอิสริยาภรณ์</q-tooltip
                >
              </q-btn>
            </div>
            <div>
              <q-file
                dense
                clearable
                outlined
                v-model="fileinvoice"
                label="บันทึกผลการจ่ายใบกำกับ"
                style="min-width: 300px"
                accept=".xlsx"
              >
                <template v-slot:prepend>
                  <q-icon name="attach_file" />
                </template>
                <q-tooltip>อัพโหลดไฟล์บันทึกผลการจ่ายใบกำกับ</q-tooltip>
              </q-file>
            </div>
            <div v-if="fileinvoice !== null">
              <q-btn
                size="12px"
                flat
                round
                color="add"
                icon="mdi-upload"
                @click="perviewfile(fileinvoice, 'invoice')"
              >
                <q-tooltip>อัพโหลดไฟล์บันทึกผลการจ่ายใบกำกับ</q-tooltip>
              </q-btn>
            </div>
          </div>
          <div class="row col-12 q-pb-sm q-col-gutter-x-xs">
            <div>
              <q-select
                v-model="DataStore.insignia"
                dense
                outlined
                lazy-rules
                hide-bottom-space
                :label="`${'เครื่องราชฯ'}`"
                emit-value
                map-options
                option-label="name"
                :options="DataStore.insigniaOp"
                option-value="id"
                :readonly="false"
                :borderless="false"
                style="min-width: 150px"
                @update:model-value="selectorInsignia"
              />
            </div>
            <div>
              <q-select
                v-model="DataStore.invoiceType"
                dense
                outlined
                lazy-rules
                hide-bottom-space
                :label="`${'ใบกำกับ'}`"
                emit-value
                map-options
                option-label="name"
                :options="DataStore.invoiceTypeop"
                option-value="id"
                :readonly="false"
                :borderless="false"
                style="min-width: 150px"
                @update:model-value="
                  DataStore.searchData(
                    DataStore.invoiceType,
                    DataStore.employeeClass
                  )
                "
              />
            </div>
            <div>
              <q-select
                v-model="DataStore.employeeClass"
                dense
                outlined
                lazy-rules
                hide-bottom-space
                :label="`${'สถานภาพ'}`"
                emit-value
                map-options
                option-label="name"
                :options="DataStore.employeeClassOps"
                option-value="id"
                :readonly="false"
                :borderless="false"
                style="min-width: 150px"
                @update:model-value="
                  DataStore.searchData(
                    DataStore.invoiceType,
                    DataStore.employeeClass
                  )
                "
              />
            </div>

            <div>
              <q-btn
                @click="addData()"
                size="12px"
                flat
                round
                color="add"
                icon="mdi-plus"
              >
                <q-tooltip>เพิ่ม</q-tooltip>
              </q-btn>
            </div>

            <q-space />

            <div class="items-center" style="display: flex">
              <!-- ค้นหาข้อความใน table -->
              <q-input
                standout
                dense
                v-model="filter"
                ref="filterRef"
                outlined
                debounce="300"
                placeholder="ค้นหา"
                style="max-width: 200px"
                class="q-ml-sm"
              >
                <template v-slot:append>
                  <q-icon v-if="filter == ''" name="search" />
                  <q-icon
                    v-if="filter !== ''"
                    name="clear"
                    class="cursor-pointer"
                    @click="resetFilter"
                  />
                </template>
              </q-input>
              <!-- แสดงคอลัมน์ใน table -->
              <q-select
                v-model="visibleColumns"
                :display-value="$q.lang.table.columns"
                multiple
                outlined
                dense
                :options="columns"
                options-dense
                option-value="name"
                map-options
                emit-value
                style="min-width: 150px"
                class="gt-xs q-ml-sm"
              />
            </div>
          </div>
          <d-table
            :rows="DataStore.rows"
            :columns="columns"
            :visible-columns="visibleColumns"
            :filter="filter"
            row-key="name"
            :pagination-label="paginationLabel"
            v-model:pagination="pagination"
          >
            <template v-slot:body-cell="props">
              <q-td :props="props">
                <div v-if="props.col.name == 'no'">
                  {{ props.rowIndex + 1 }}
                </div>

                <div v-else-if="props.col.name == 'action'">
                  <q-btn
                    dense
                    size="12px"
                    flat
                    round
                    color="primary"
                    @click.stop="editData(props.row)"
                    icon="mdi-pencil-outline"
                  >
                    <q-tooltip>แก้ไขข้อมูล</q-tooltip>
                  </q-btn>
                </div>

                <div v-else>
                  {{ props.value }}
                </div>
              </q-td>
            </template>
          </d-table>
        </div>
      </q-tab-panel>
      <q-tab-panel name="doc" class="q-pa-none">
        <fileUploadview :roundId="selectRound" />
      </q-tab-panel>
    </q-tab-panels>

    <DialogForm
      :modal="modal"
      :save="save"
      :close="close"
      :roundId="selectRound"
      :action="action"
      :personId="personId"
      :profileType="profileType"
    />
  </q-card>
  <q-card v-else>
    <div class="q-pa-md q-gutter-sm">
      <q-banner inline-actions rounded class="bg-grey-1 text-center">
        ไม่มีข้อมูลรอบการเสนอขอพระราชทานเครื่องราชอิสริยาภรณ์
      </q-banner>
    </div>
  </q-card>

  <q-dialog v-model="modelPerview">
    <q-card style="width: 850px; max-width: 80vw">
      <q-card-section>
        <q-toolbar class="q-py-md">
          <q-toolbar-title class="header-text">
            ยืนยันรายการข้อมูล
          </q-toolbar-title>
          <q-btn
            icon="close"
            unelevated
            round
            dense
            v-close-popup
            style="color: #ff8080; background-color: #ffdede"
          />
        </q-toolbar>
        <!-- <div class="text-h6">ยืนยันรายการข้อมูล</div> -->
      </q-card-section>

      <q-card-section class="q-pt-none">
        <d-table
          :rows="rowspreview"
          :columns="columns"
          :visible-columns="visibleColumns"
          :filter="filter"
          row-key="name"
        >
          <template v-slot:body-cell="props">
            <q-td :props="props">
              <div v-if="props.col.name == 'no'">
                {{ props.rowIndex + 1 }}
              </div>
              <div v-else>
                {{ props.value }}
              </div>
            </q-td>
          </template>
        </d-table>
      </q-card-section>
      <q-card-actions align="right" class="text-primary">
        <q-btn
          unelevated
          dense
          color="public"
          label="บันทึก"
          @click="uploadFile(fileInsignia, typepreview)"
        />
      </q-card-actions>
    </q-card>
  </q-dialog>
</template>
<style lang="scss" scoped>
.arrow {
  transition: transform 0.5s;
}

.arrow-active {
  transition: transform 0.5s;
  transform: rotate(-90deg);
}

.bg-base {
  background-color: #f3f3f398;
}

.v-enter-active,
.v-leave-active {
  transition: opacity 0.5s ease;
}

.v-enter-from,
.v-leave-to {
  opacity: 0;
}

.flexsave {
  display: flex;
  justify-content: flex-end;
}
</style>
